﻿#include <ESP8266WiFi.h> // Include the library for ESP8266 WiFi functionality.
#include <MQTT.h>  // Include the MQTT library for messaging between devices.
#include <Servo.h>  // Include the Servo library for controlling servo motors.
const char ssid[] = "StudentResidences";// Define the Wi-Fi SSID
const char pass[] = ""; // Define the Wi-Fi password
WiFiClient net;  // Create a WiFiClient
MQTTClient client; // Create an MQTTClient
unsigned long lastMillis = 0; // Variable for tracking time intervals
Servo myservo; // Create a Servo object to control the servo motor.
int servoPosition; // Variable to store the current position of the servo motor.






void connect() {
  Serial.print("checking wifi..."); // Print message to indicate that Wi-Fi connection is being checked.
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print("."); // Print a dot to show that it’s still checking.
    delay(1000);// Wait for 1 second before checking again.
  }
  Serial.print("\nconnecting..."); // Once connected, print "connecting..." message.
  while (!client.connect("AilsaID", "", "")) {
    Serial.print(".");
    delay(1000);
  }
  Serial.println("\nconnected!");
  client.subscribe("Benjikershawdust"); // Subscribe to the topic
}


void messageReceived(String &topic, String &payload) { //Connects to the topic on the MQTT broker, and returns the most recent data in that topic.
  //Data is held in the variable "payload"
  Serial.println("incoming: " + topic + " - " + payload);
  int myVal = payload.toInt();  //convert the payload to an integer (if it actually is an integer)
  Serial.println(myVal); // Print the converted integer value.




   if (myVal < 0) { // If the value is less than 0
    myservo.write(100);  // Set the servo position to 100 degrees.
   }
  else if (myVal >1 && myVal< 21) { // If the value is between 1 and 21
    myservo.write(115); // Set the servo position to 115 degrees.


  }
  else if (myVal >22 && myVal< 42) { // If the value is between 22 and 42
    myservo.write(135); // Set the servo position to 135 degrees.
  }


  else if (myVal >43 && myVal< 63) {
    myservo.write(150);
  }
    else if (myVal >64 && myVal< 85) {
    myservo.write(160);
  }
    else if (myVal >86 && myVal< 106) {
    myservo.write(170);
  }
 
     else if (myVal >107 && myVal< 130) {
    myservo.write(174);
  }
}


void setup() {
  Serial.begin(115200); // serial communication at 115200 baud rate
  WiFi.begin(ssid, pass);
  client.begin("134.36.5.199", net);
  client.onMessage(messageReceived);
  connect(); // Call the connect function to reconnect to Wi-Fi and the MQTT broker.
  myservo.attach(D4,500,2400); // Attach the servo to pin D4, with a pulse width range from 500 to 2400
 
   
}


void loop() {
  client.loop();  // Keep the MQTT client running and checking for new messages.
  delay(10);   // delay for 10 milliseconds


  if (!client.connected()) { // If the MQTT client is not connected
    connect();
  }
}